// Demonstrations of binary search with Strings
public class BinarySearchStrings{

  // Iterative
  // Use binary search to locate String key in an array a
  public static int binarySearch(String a[], String key){
    int left=0, right=a.length-1;
    int mid = 0;
    while(left <= right){
      mid = (left+right)/2;
      if(key.compareTo(a[mid])==0){
	return mid;
      }else if(key.compareTo(a[mid]) < 0){
	right = mid-1;
      }
      else{
	left = mid+1;
      }
    }
    return -1;
  }

  public static void main(String args[]){
    String [] arr = {"A","B","E","G","H","K","M","T","V"};
    //                0   1   2   3   4   5   6   7   8
    System.out.println(java.util.Arrays.toString(arr));

    System.out.println( "A: " + binarySearch( arr,"A") );
    System.out.println( "C: " + binarySearch( arr,"C") );
    System.out.println( "L: " + binarySearch( arr,"L") );
    System.out.println( "K: " + binarySearch( arr,"K") );
    System.out.println( "U: " + binarySearch( arr,"U") );
    System.out.println( "V: " + binarySearch( arr,"V") );
    System.out.println( "Z: " + binarySearch( arr,"Z") );

  }

}
