// Demonstrate a comparator which sorts according to a new ordering of
// integers: odds before evens.
import java.util.*;

class OddsThenEvens implements Comparator<Integer>{
  public int compare(Integer x, Integer y){
    boolean xOdd = x%2==1;
    boolean yOdd = y%2==1;
    if(xOdd==yOdd){
      return x-y;
    }
    else if(xOdd){
      return -1;
    }
    else{
      return +1;
    }
  }
}

public class OddsFirst{
  public static void main(String args[]){
    Comparator<Integer> cmp = new OddsThenEvens();
    Integer a[];

    a = new Integer[]{4, 5, 9, 2, 3, 1, 8};
    System.out.println(Arrays.toString(a));
    Arrays.sort(a,cmp);
    System.out.printf("%s\n\n",Arrays.toString(a));
    // [1, 3, 5, 9, 2, 4, 8]

    a = new Integer[]{2048, 1024, 5096, 128, 9999};
    System.out.println(Arrays.toString(a));
    Arrays.sort(a,cmp);
    System.out.printf("%s\n\n",Arrays.toString(a));
    // [9999, 128, 1024, 2048, 5096]
  }
}
