// Sort command line integers using insertion sort
//
// usage: java InsertionSort 9 7 3 10 1 2 4 6 8 5
public class InsertionSort{
  // The insertion sort algorithm
  public static void insertionSort(int arr[]){
    for(int i=1; i<arr.length-1; i++){
      int m = i;
      while( m > 0 && arr[m-1] > arr[m]) { 
	int tmp = arr[m-1];
	arr[m-1] = arr[m];
	arr[m] = tmp;
        m = m - 1;
      }
    }
    return;
  }

  // Read and sort integers on the command line
  public static void main(String args[]){
    int arr[] = new int[args.length];
    for(int i=0;i<args.length; i++){
      arr[i] = Integer.parseInt(args[i]);
    }
    System.out.println(java.util.Arrays.toString(arr));
    insertionSort(arr);
    System.out.println(java.util.Arrays.toString(arr));
  }

}
