// Integer selection sort demonstration with main method
public class SelectionSort{

  public static void selectionSort(int[] a) {
    for (int i = 0; i < a.length - 1; i++) {
      int smallest = i;
      for (int j = i + 1; j < a.length; j++) {
        if (a[j] < a[smallest]) {
          smallest = j;
        }
      }
      swap(a, i, smallest);
    }
  }
  public static void swap(int[] a, int i, int j) {
    int temp = a[i]; a[i] = a[j]; a[j] = temp;
  }

  // Read and sort integers on the command line
  public static void main(String args[]){
    int arr[] = new int[args.length];
    for(int i=0;i<args.length; i++){
      arr[i] = Integer.parseInt(args[i]);
    }
    System.out.println(java.util.Arrays.toString(arr));
    selectionSort(arr);
    System.out.println(java.util.Arrays.toString(arr));
  }
}
